// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined } from '../runtime';
import type { OperationOpts, HttpHeaders } from '../runtime';
import type {
    EgfaModuleEnapEntityDTO,
    ZeitplanungEntityDTO,
    ZeitplanungsvorlageEntityDTO,
} from '../models';

export interface CreateEnapPdfSummaryRequest {
    egfaModuleEnapEntityDTO: EgfaModuleEnapEntityDTO;
}

export interface CreateZeitplanungPdfSummaryRequest {
    zeitplanungEntityDTO: ZeitplanungEntityDTO;
}

export interface CreateZeitplanungsvorlagePdfSummaryRequest {
    zeitplanungsvorlageEntityDTO: ZeitplanungsvorlageEntityDTO;
}

/**
 * no description
 */
export class ExportControllerApi extends BaseAPI {

    /**
     * Erzeugt eine eGFA eNAP Zusammenfassung als Export
     * eGFA eNAP Zusammenfassung exportieren
     */
    createEnapPdfSummary({ egfaModuleEnapEntityDTO }: CreateEnapPdfSummaryRequest): Observable<Blob>
    createEnapPdfSummary({ egfaModuleEnapEntityDTO }: CreateEnapPdfSummaryRequest, opts?: OperationOpts): Observable<AjaxResponse<Blob>>
    createEnapPdfSummary({ egfaModuleEnapEntityDTO }: CreateEnapPdfSummaryRequest, opts?: OperationOpts): Observable<Blob | AjaxResponse<Blob>> {
        throwIfNullOrUndefined(egfaModuleEnapEntityDTO, 'egfaModuleEnapEntityDTO', 'createEnapPdfSummary');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Blob>({
            url: '/export/enap/pdf',
            method: 'POST',
            headers,
            body: egfaModuleEnapEntityDTO,
            responseType: 'blob',
        }, opts?.responseOpts);
    };

    /**
     * Erzeugt eine Zeitplanung Zusammenfassung als Export
     * Zeitplanung Zusammenfassung exportieren
     */
    createZeitplanungPdfSummary({ zeitplanungEntityDTO }: CreateZeitplanungPdfSummaryRequest): Observable<Blob>
    createZeitplanungPdfSummary({ zeitplanungEntityDTO }: CreateZeitplanungPdfSummaryRequest, opts?: OperationOpts): Observable<AjaxResponse<Blob>>
    createZeitplanungPdfSummary({ zeitplanungEntityDTO }: CreateZeitplanungPdfSummaryRequest, opts?: OperationOpts): Observable<Blob | AjaxResponse<Blob>> {
        throwIfNullOrUndefined(zeitplanungEntityDTO, 'zeitplanungEntityDTO', 'createZeitplanungPdfSummary');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Blob>({
            url: '/export/zeitplanung/pdf',
            method: 'POST',
            headers,
            body: zeitplanungEntityDTO,
            responseType: 'blob',
        }, opts?.responseOpts);
    };

    /**
     * Erzeugt eine Zeitplanungsvorlage Zusammenfassung als Export
     * Zeitplanungsvorlage Zusammenfassung exportieren
     */
    createZeitplanungsvorlagePdfSummary({ zeitplanungsvorlageEntityDTO }: CreateZeitplanungsvorlagePdfSummaryRequest): Observable<Blob>
    createZeitplanungsvorlagePdfSummary({ zeitplanungsvorlageEntityDTO }: CreateZeitplanungsvorlagePdfSummaryRequest, opts?: OperationOpts): Observable<AjaxResponse<Blob>>
    createZeitplanungsvorlagePdfSummary({ zeitplanungsvorlageEntityDTO }: CreateZeitplanungsvorlagePdfSummaryRequest, opts?: OperationOpts): Observable<Blob | AjaxResponse<Blob>> {
        throwIfNullOrUndefined(zeitplanungsvorlageEntityDTO, 'zeitplanungsvorlageEntityDTO', 'createZeitplanungsvorlagePdfSummary');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Blob>({
            url: '/export/zeitplanungsvorlage/pdf',
            method: 'POST',
            headers,
            body: zeitplanungsvorlageEntityDTO,
            responseType: 'blob',
        }, opts?.responseOpts);
    };

}
